//sketch che pilota il manipolatore con Arduino Nano

#include <Servo.h>
//********************************
Servo base;  
Servo spalla;
Servo gomito;
Servo polso;
Servo pinza;
//********************************
int posbase=base.read(); 
int gradibaseold=0;  

int posspalla = spalla.read(); 
int gradispallaold=0;

int posgomito = gomito.read(); 
int gradigomitoold=0;

int pospolso = polso.read();
int gradipolsoold=0;

int pospinza = pinza.read(); 
int gradipinzaold=0;
//*****************************

int tempo=40;
int tempomov=1000;
int led=13;

String datoInput;
String datoInputGradi;
int gradi;

//**************************** 

void setup() 
{
 base.attach(6);  
 spalla.attach(7);
  gomito.attach(8);
 polso.attach(9); 
 pinza.attach(10);

base.write(posbase); 
gradibaseold=posbase;

spalla.write(posspalla); 
gradibaseold=posbase;

gomito.write(posgomito); 
gradigomitoold=posgomito;

polso.write(pospolso); 
gradipolsoold=pospolso;

pinza.write(pospinza); 
gradipinzaold=pospinza;

pinMode(led,OUTPUT);

 
//*************************** 
 Serial.begin(115200);
//*************************** 
 gradibaseold=base.read();
 gradispallaold=spalla.read();
 gradigomitoold=gomito.read();
 gradipolsoold=polso.read();
 gradipinzaold=pinza.read();

 base.write(gradibaseold);
 spalla.write(gradispallaold);
 gomito.write(gradigomitoold);
 polso.write(gradipolsoold);
 pinza.write(gradipinzaold);
 

//***************************
 delay(3000);
}

void loop() 
{
   if(Serial.available()>0)
    {  
    datoInput= Serial.readStringUntil('Z');
    delay(50);
    datoInputGradi=datoInput.substring(1,4);
    delay(50);
    gradi=datoInputGradi.toInt();
    delay(50);
 
        if(datoInput.startsWith("0")==true)
        {
        basemov(gradi);
        delay(50);
        }

        if(datoInput.startsWith("1")==true)
        {
        spallamov(gradi);
        delay(50);
        }

        if(datoInput.startsWith("2")==true)
        {
        gomitomov(gradi);
        delay(50);
        }

        if(datoInput.startsWith("3")==true)
        {
        polsomov(gradi);
        delay(10);
        }

        if(datoInput.startsWith("4")==true)
        {
       pinzamov(gradi);
        delay(50);
        }
    }
}

void basemov(int gradibase)
{ 
  if(gradibase<=gradibaseold)
  {
  for (posbase = gradibaseold; posbase > gradibase; posbase --) 
  { 
     base.write(posbase); 
     Serial.print("posbase e' ");   
     Serial.println(posbase);            
     delay(tempo);                       
  }
  gradibaseold=posbase; 
  } 
  else if (gradibase>=gradibaseold)
  { 
  for (posbase = gradibaseold; posbase < gradibase; posbase ++) 
  { 
    base.write(posbase);      
    delay(tempo);                       
  }
   gradibaseold=posbase; 
  }      
}

void spallamov(int gradispalla)
{ 
  if(gradispalla<=gradispallaold)
  {
  for (posspalla = gradispallaold; posspalla > gradispalla; posspalla --) 
  { 
     spalla.write(posspalla); 
      delay(tempo);                       
  }
  gradispallaold=posspalla; 
  } 
  else if (gradispalla>=gradispallaold)
  { 
  for (posspalla = gradispallaold; posspalla < gradispalla; posspalla ++) 
  { 
    spalla.write(posspalla);      
    delay(tempo);                       
  }
   gradispallaold=posspalla; 
  }      
}

void gomitomov(int gradigomito)
{ 
  if(gradigomito<=gradigomitoold)
  {
  for (posgomito = gradigomitoold; posgomito > gradigomito; posgomito --) 
  { 
     gomito.write(posgomito); 
      delay(tempo);                       
  }
  gradigomitoold=posgomito; 
  } 
  else if (gradigomito>=gradigomitoold)
  { 
  for (posgomito = gradigomitoold; posgomito < gradigomito; posgomito ++) 
  { 
    gomito.write(posgomito);      
    delay(tempo);                       
  }
   gradigomitoold=posgomito; 
  } 
    delay(50);     
}

void polsomov(int gradipolso)
{ 
  if(gradipolso<=gradipolsoold)
  {
  for (pospolso = gradipolsoold; pospolso > gradipolso; pospolso --) 
  { 
     polso.write(pospolso); 
      delay(tempo);                       
  }
  gradipolsoold=pospolso; 
  } 
  else if (gradipolso>=gradipolsoold)
  { 
  for (pospolso = gradipolsoold; pospolso < gradipolso; pospolso ++) 
  { 
    polso.write(pospolso);      
    delay(tempo);                       
  }
   gradipolsoold=pospolso; 
  } 
    delay(50);     
}

void pinzamov(int gradipinza)
{ 
  if(gradipinza<=gradipinzaold)
  {
  for (pospinza = gradipinzaold; pospinza > gradipinza; pospinza --) 
  { 
     pinza.write(pospinza); 
      delay(tempo);                       
  }
  gradipinzaold=pospinza; 
  } 
  else if (gradipinza>=gradipinzaold)
  { 
  for (pospinza = gradipinzaold; pospinza < gradipinza; pospinza ++) 
  { 
    pinza.write(pospinza);      
    delay(tempo);                       
  }
   gradipinzaold=pospinza; 
  } 
    delay(50);     
}
